#!/bin/sh
#devine.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $Id: play_devine.tcl,v 1.9 2006/03/25 00:55:15 abuledu_francois Exp $
#  Author  : andre.connes@wanadoo.fr
#  Date    : 05/01/2003 Modification : 16/02/2004
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     Andre Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

source devine.conf
source msg.tcl
source fin_sequence.tcl
source lanceapplication.tcl
global fichier_image
global zone_focus
global ind

set zone_focus ""
set ind 0

set fichier_image [lindex $argv 0]
  #
  # langue par defaut
  #
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]

# Decommenter la ligne suivante si Img est installee
 package require Img

####################################################
#
# sauvegarde
#
####################################################

proc sauvegarde { } {
  global glob bgimg
  # sauvegarder les donnees de l'image actuelle
  if { [llength $glob(list_zones)] <= 1 } {
    return
  }
  catch { [file mkdir [file join [pwd] zones]] }
  set nom_image [file rootname [file tail $bgimg]]
  set f [open [file join [pwd] zones $nom_image] "w"] 
  puts $f $glob(list_zones)
  close $f
} ;# sauvegarde

###########################################""
#
#modifier zone
#
##########################################

proc ok_zone_modif { } {
  global glob can_img can_zones v_width v_height cache ind can_zones2
w_enabled
	set newind [expr $ind +1]
	set var_zone "zone$newind"
    set zliste [list $var_zone]
    for {set i 0} {$i < $glob(nbrow)} { incr i 1} {
      for {set j 0} {$j < $glob(nbcol)} {incr j 1 } {
        if {$cache($i,$j) == 1} {
          lappend zliste "$i $j"
          set cache($i,$j) 9 ;# ne pas reutiliser
          #$can_img create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
          #  [expr $glob(org) + ($j+1)*$v_width -1] [expr $glob(org) + ($i+1)*$v_height -1] \
           # -fill red -tag "rect [string map { \040 "" } [concat a$i a$j]]" -width 1
	$can_img itemconfigure [string map { \040 "" } [concat a$i a$j]] -fill red

        }
      }
    }
    # maintenir la liste des zones
    #lappend glob(list_zones) $zliste
set glob(list_zones) [lreplace $glob(list_zones) $newind $newind $zliste]

    # desactiver le bouton pouce
   bind $can_img <Button-1> ""
destroy $can_zones2
$can_zones.labobj configure -text "Liste des zones"
#$can_zones.but_modif configure -command "modifie_zone" -text "Modifier la zone"
#$can_zones.listsce insert end $var_zone
} ;#ok_zone_modif


####################################################
#
# ajouter_zone
#
####################################################

proc ok_zone { } {
  global glob can_img can_zones v_width v_height cache can_zones2
w_enabled
  # activer/desactiver le pouce
  set n 0
  for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
    for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
      if { $cache($i,$j) == 1 } {
        set n 1
      }
    }
  }
  if { $n != 1 } {
tk_messageBox -message "Aucune slection n'a t effectue sur l'image"
return
  }

    set sysFont {Helvetica 15 bold} ;# {Geneva 15 bold}{Adobe-Courier 15 bold}
    set glob(nzone) [expr $glob(nzone) +1]
    # numero du carre-zone
    #$can_zones create text 30 [expr 15*$glob(nzone)]  \
    #  -fill red -text "$glob(nzone). " ;# -tag nzone_$glob(nzone)
    # entree des mots-cles de la zone
    #$can_zones create text 50 [expr 15*$glob(nzone)] \
    #  -fill black -anchor w -text "zone $glob(nzone)" ;# -tag tzone_$glob(nzone) 
    # maintenir la liste des cases selectionnees
	set var_zone "zone"
	set var_zone $var_zone$glob(nzone)
    set zliste [list $var_zone]
    for {set i 0} {$i < $glob(nbrow)} { incr i 1} {
      for {set j 0} {$j < $glob(nbcol)} {incr j 1 } {
        if {$cache($i,$j) == 1} {
          lappend zliste "$i $j"
          set cache($i,$j) 9 ;# ne pas reutiliser
          $can_img create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
            [expr $glob(org) + ($j+1)*$v_width -1] [expr $glob(org) + ($i+1)*$v_height -1] \
            -fill red -tag "rect [string map { \040 "" } [concat a$i a$j]]" -width 1
        }
      }
    }
    # maintenir la liste des zones
    lappend glob(list_zones) $zliste
    # desactiver le bouton pouce
    #.bframe.but_pouce configure -state disabled
   bind $can_img <Button-1> ""
#$can_zones.but_pouce configure -command "ajoute_zone" -text "  Ajouter une zone  "
$can_zones.listsce insert end $var_zone
destroy $can_zones2
$can_zones.labobj configure -text "Liste des zones"
} ;#ok_zone



####################################################
#
# selectionner
#
####################################################

proc selectionner_rect {i j } {
  global glob cache rect v_width v_height can_img
  if { $cache($i,$j) == 0 } {
      set cache($i,$j) 1
      $can_img create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
        [expr $glob(org) + ($j+1)*$v_width -1] [expr $glob(org) + ($i+1)*$v_height -1] \
        -fill $glob(rectcolor) -tag "rect [string map { \040 "" } [concat a$i a$j]]" -width 1
  } elseif { $cache($i,$j) == 1 } {
      set cache($i,$j) 0
      $can_img delete [string map { \040 "" } [concat a$i a$j]]

  }
} ;# selectionner_rect

####################################################
#
# quadrillage
#
####################################################

proc row_quadrillage {} {
  global glob can_img
  for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
      for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
        $can_img delete [string map { \040 "" } [concat a$i a$j]]
      }
  }
  set glob(nbrow) [.frame.d.d.nbrow get]
  quadrillage
}

proc col_quadrillage {} {
  global glob can_img
  for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
      for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
        $can_img delete #[string map { \040 "" } [concat a$i a$j]]
      }
  }
  set glob(nbcol) [.frame.d.d.nbcol get]

  quadrillage
}

proc clicwhat {can x y} {
  global glob v_width v_height
  set itot [expr $x- $glob(org)]
  set i [expr $itot/$v_width]

  set jtot [expr $y- $glob(org)]
  set j [expr $jtot/$v_height]
  if {$i>=0 && $j>= 0 && $i < $glob(nbcol) && $j < $glob(nbrow)} {
    selectionner_rect $j $i
  }
}

proc quadrillage { } {
global can_img can_zones glob cache cadre bgimage v_width v_height fichier_image ind zone_focus
  catch { delete cache }
  $can_zones delete all
    $can_img delete all
set ind 0
set zone_focus ""
  # initialiser la sauvegarde des zones
  set glob(nzone) 0
  set glob(list_zones) [list "$glob(nbrow) $glob(nbcol)"]

  set bgimg $fichier_image
  
  set bgimage [image create photo -file [file join images $bgimg]]

  set hbgimage [image height $bgimage]
  set wbgimage [image width $bgimage]

  $can_img create image \
	[expr $glob(org) + int($wbgimage/2)+1] [expr $glob(org) + int($hbgimage/2)+1] -image $bgimage

  set v_height [expr ($hbgimage + $glob(nbrow)) / $glob(nbrow) +0]
  set v_width [expr ($wbgimage + $glob(nbcol)) / $glob(nbcol) +0]

    for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
      for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
        $can_img create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
	  [expr $glob(org) + ($j+1)*$v_width +1] [expr $glob(org) + ($i+1)*$v_height +1] \
	  -width 1
      }
    }

  # on encadre tout
  for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
    for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
      $can_img create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
        [expr $glob(org) + ($j+1)*$v_width -0] [expr $glob(org) + ($i+1)*$v_height -0] \
        -width 1 
      set cache($i,$j) 0  
    }
  }
 $can_zones.listsce delete 0 end 

} ;# quadrillage

# #################################################################################
#
#                                   main
#
# #################################################################################

proc main { can_img } {
global can_zones glob cache cadre bgimage v_width v_height fichier_image bgimg
  $can_img delete all

  # afficher l'image sélectionnée
set bgimg $fichier_image
set bgimage [image create photo -file [file join images $bgimg]]

if { [file exists [file join [pwd] zones [file rootname [file tail $bgimg]]]] } {
	set f [open [file join [pwd] zones [file rootname [file tail $bgimg]]] "r"]
  	gets $f glob(list_zones)
	set glob(nbrow) [lindex [lindex $glob(list_zones) 0] 0]
	set glob(nbcol) [lindex [lindex $glob(list_zones) 0] 1]
	close $f
.frame.d.d.nbrow set $glob(nbrow)
.frame.d.d.nbcol set $glob(nbcol)

set glob(nzone) [expr [llength $glob(list_zones)] -1]

set hbgimage [image height $bgimage]
set wbgimage [image width $bgimage]

  set v_height [expr ($hbgimage + $glob(nbrow)) / $glob(nbrow) +0]
  set v_width [expr ($wbgimage + $glob(nbcol)) / $glob(nbcol) +0]
$can_img create image \
	[expr $glob(org) + int($wbgimage/2)+1] [expr $glob(org) + int($hbgimage/2)+1] -image $bgimage


    for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
      for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
        $can_img create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
	  [expr $glob(org) + ($j+1)*$v_width +1] [expr $glob(org) + ($i+1)*$v_height +1] \
	  -width 1 -tags vtag($i,$j)
      }
    }

  # on encadre tout
  for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
    for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
      $can_img create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
        [expr $glob(org) + ($j+1)*$v_width -0] [expr $glob(org) + ($i+1)*$v_height -0] \
        -width 1
      set cache($i,$j) 0  
    }
}

$can_zones.listsce delete 0 end 

for {set i 1} {$i < [llength $glob(list_zones)]} {incr i} {
 set temp [lindex $glob(list_zones) $i]
$can_zones.listsce insert end [lindex $temp 0]

for {set j 1} {$j < [llength $temp]} {incr j} {
      set cache([lindex [lindex $temp $j] 0],[lindex [lindex $temp $j] 1]) 9
      $can_img create rect [expr $glob(org) + [lindex [lindex $temp $j] 1]*$v_width +1] [expr $glob(org) + [lindex [lindex $temp $j] 0]*$v_height +1] \
        [expr $glob(org) + ([lindex [lindex $temp $j] 1] +1)*$v_width -1] [expr $glob(org) + ([lindex [lindex $temp $j] 0] +1)*$v_height -1] \
        -fill red -tags "rect [string map { \040 "" } [concat a [lindex [lindex $temp $j] 0] a [lindex [lindex $temp $j] 1]]]" -width 1
}


}

} else {
.frame.d.d.nbrow set $glob(nbrow)
.frame.d.d.nbcol set $glob(nbcol)
row_quadrillage
col_quadrillage
}


} ;# main

proc changelistsce {x y} {
global zone_focus can_zones glob v_width v_height can_img ind
set ind [$can_zones.listsce index @$x,$y]
set zone_focus [$can_zones.listsce get $ind]
 set temp [lindex $glob(list_zones) [expr $ind+1]]
	$can_img itemconfigure rect -fill red

for {set j 1} {$j < [llength $temp]} {incr j} {
	$can_img itemconfigure [string map { \040 "" } [concat a [lindex [lindex $temp $j] 0] a [lindex [lindex $temp $j] 1]]] -fill orange
}



}

proc ajoute_zone {} {
global can_img can_zones can_zones2 glob
 bind $can_img <Button-1> "clicwhat $can_img %x %y"
canvas $can_zones2 -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $can_zones2 -side top  

button $can_zones2.but_ok -command "ok_zone" -text "  Ok  "
$can_zones.labobj configure -text "Ajout d'une zone"

pack $can_zones2.but_ok -side bottom -pady 20
w_disabled
#$can_zones.but_pouce configure -text "Ok " -command "ok_zone"
}

proc modifie_zone {} {
global can_img can_zones zone_focus ind glob cache can_zones2
if {$zone_focus !=""} {
canvas $can_zones2 -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $can_zones2 -side top  
$can_zones.labobj configure -text "Modification de la zone"

button $can_zones2.but_ok -command "ok_zone_modif" -text "  Ok  "
pack $can_zones2.but_ok -side bottom -pady 20
w_disabled

set temp [lindex $glob(list_zones) [expr $ind+1]]
$can_img itemconfigure rect -fill red

for {set j 1} {$j < [llength $temp]} {incr j} {
      set cache([lindex [lindex $temp $j] 0],[lindex [lindex $temp $j] 1]) 1
	$can_img itemconfigure [string map { \040 "" } [concat a [lindex [lindex $temp $j] 0] a [lindex [lindex $temp $j] 1]]] -fill blue
}

 bind $can_img <Button-1> "clicwhat $can_img %x %y"
} else {
tk_messageBox -message "Il n'y a pas de zone slectionne."
}
}



proc supprime_zone {} {
global can_img can_zones zone_focus ind glob cache can_zones2 glob
if {$zone_focus !=""} {

set answer [tk_messageBox -message "Confirmation de la suppression" -type okcancel -icon question]
switch -- $answer {
    cancel return
}

set temp [lindex $glob(list_zones) [expr $ind+1]]

$can_zones.listsce delete 0 end 
for {set j 1} {$j < [llength $temp]} {incr j} {
      set cache([lindex [lindex $temp $j] 0],[lindex [lindex $temp $j] 1]) 0
	$can_img delete [string map { \040 "" } [concat a [lindex [lindex $temp $j] 0] a [lindex [lindex $temp $j] 1]]]
}

set glob(list_zones)  [lreplace $glob(list_zones) [expr $ind+1] [expr $ind+1]] 
set zz 1
set listtemp ""
for {set j 1} {$j < [llength $glob(list_zones)]} {incr j} {
      set temp1 [lindex $glob(list_zones) $j]
set zone "zone$zz"
$can_zones.listsce insert end $zone

set temp1  [lreplace $temp1 0 0 $zone]
lappend listtemp $temp1
incr zz
}
set glob(nzone) [expr $glob(nzone) -1]
set glob(listzones) $listtemp
} else {
tk_messageBox -message "Il n'y a pas de zone slectionne."
}
}




proc w_disabled {} {
global can_zones
$can_zones.listsce configure -state disabled
$can_zones.but_pouce configure -state disabled
$can_zones.but_modif configure -state disabled
$can_zones.but_sup configure -state disabled
}

proc w_enabled {} {
global can_zones
$can_zones.listsce configure -state normal
$can_zones.but_pouce configure -state normal
$can_zones.but_modif configure -state normal
$can_zones.but_sup configure -state normal
}

#####################################################################################
#
# fenetre principale
#
#      placement de la fenetre en haut et a gauche de l'ecran
#
#####################################################################################
#wm resizable . 0 0
#wm geometry . [expr [winfo screenwidth .]-10]x[expr [winfo screenheight .]-80]+0+0
. configure -bg $glob(bgcolor)
  wm title . "[mc title_ed] : [file rootname $fichier_image]"

frame .frame -bg $glob(bgcolor)
pack .frame -side top -fill both -expand yes

# ################ On cree un canvas image ###########################################
# a gauche

set can_img .frame.c
canvas $can_img -width $glob(width) -height $glob(height) -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $can_img -side left -expand true 

# ####################################################################################
# une frame a droite de ce canvas

set f .frame.d 
frame $f -bg $glob(bgcolor)
pack $f -side left -expand true

# ################ On y cree un canvas parametres ####################################

set can_parametres $f.d
canvas $can_parametres -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $can_parametres -side top -expand true 

  # nombre lignes / colonnes
  set glob(nbrow) 4
  scale $can_parametres.nbrow -from 3 -to 30 -label [mc nbrow] -orient horizontal \
    -borderwidth 4 -length 140 -relief groove
  pack $can_parametres.nbrow -side left -padx 10 -pady 20
  bind $can_parametres.nbrow <ButtonRelease-1> "row_quadrillage" 

  set glob(nbcol) 5
  scale $can_parametres.nbcol -from 3 -to 30 -label [mc nbcol] -orient horizontal \
    -borderwidth 4 -length 140 -relief groove
  #set nbcol $glob(nbcol)
  pack $can_parametres.nbcol -side left -padx 10 -pady 20
  bind $can_parametres.nbcol <ButtonRelease-1> "col_quadrillage" 

  set glob(nbmax) $glob(nbcol) ;# ?

# ############## On y cree un canvas pour numeros et descriptions de zones ###########
set can_zones $f.e
set can_zones2 $f.f

canvas $can_zones -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $can_zones -side top -expand true  

label $can_zones.labobj -font {Helvetica 10} -text "Liste des zones" -bg $glob(bgcolor)
pack $can_zones.labobj -side top -pady 20

listbox $can_zones.listsce -yscrollcommand "$can_zones.scrollpage set" -width 15 -height 10 
scrollbar $can_zones.scrollpage -command "$can_zones.listsce yview" -width 7 
pack $can_zones.listsce $can_zones.scrollpage -side left -fill y -expand 1 
bind $can_zones.listsce <ButtonRelease-1> "changelistsce %x %y"
  
button $can_zones.but_pouce -command "ajoute_zone" -text "  Ajouter une zone  "
pack $can_zones.but_pouce -padx 10 -side bottom -pady 20
#button $can_zones.but_pouce -command "ok_zone" -text "  Ajouter la zone  "
#pack $can_zones.but_pouce -padx 10 -side bottom -pady 20

button $can_zones.but_modif -command "modifie_zone" -text "  Modifier la zone  "
pack $can_zones.but_modif -padx 10 -side bottom -pady 20

button $can_zones.but_sup -command "supprime_zone" -text "Supprimer la zone"
pack $can_zones.but_sup -padx 10 -side bottom -pady 20



# ############# on cree une frame pour pouce, porte ##################################
# en bas

frame .bframe -bg $glob(bgcolor)
pack .bframe -side bottom -expand true



  button .bframe.but_quitter -image \
    [image create photo fquitter \
    -file [file join sysdata quitter_minus.png]] \
    -command "sauvegarde; lanceappli editeur.tcl" -text "Enregistrer et quitter"
  pack .bframe.but_quitter -padx 10

main $can_img

